//+------------------------------------------------------------------+
//|                                          |
//|                      Copyright  2011, GMX[23RUS]                |
//|                        locke_13@rambler.ru                       |
//+------------------------------------------------------------------+

extern double TakeProfit = 0;
extern double LotSize = 0.1;
extern double TrailStop = 30;
extern int StopLoss=55;
extern int MAper=7;
datetime newBar;
int magic=13;
int counterB=0;
int counterS=0;
int count=20;
int MacdPer=PERIOD_H1;
int StPer=PERIOD_M30;
int ThurdP=PERIOD_M5;
int dep;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
      ObjectCreate("my", OBJ_LABEL, 0, 0, 0);
      ObjectSet("my", OBJPROP_CORNER, 1);      
      ObjectSet("my", OBJPROP_XDISTANCE, 10 ); 
      ObjectSet("my", OBJPROP_YDISTANCE, 15);
      newBar=iTime(NULL, StPer, 0);
      dep=AccountBalance();
}

int start()
{
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }
   datetime bar=iTime(NULL, StPer, 0);
   if (bar==0) Alert("bar=0");
   if (bar!=newBar)            //  ?
   {
      OrdModif();
      Thurd();
      TrailingStop(TrailStop);
      newBar=bar;
      Lot();
   }
   return(0);
}


int MACDsamp()  //   -  MACD
{
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, MaCurrent, MaPrevious;
   int total;

   MacdCurrent=iMACD(NULL,MacdPer,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   MacdPrevious=iMACD(NULL,MacdPer,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
   SignalCurrent=iMACD(NULL,MacdPer,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   SignalPrevious=iMACD(NULL,MacdPer,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);
   
      // no opened orders identified
      if(AccountFreeMargin()<(1000*LotSize))
      {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
      }
      //    -    
      if(MacdPrevious<MacdCurrent)  
      {
            return(1);
      }
      //   -  
      if( MacdPrevious>MacdCurrent) 
      {
            return(-1);   
      }
      return(0);
}

int Stoch()         //   - ,    ADX -       -  
{
   int ball=0;
   double StCurrent, StPrev;
   StCurrent=iStochastic(NULL, StPer, 6, 2, 1, MODE_EMA, 0, MODE_MAIN, 0);
   StPrev=iStochastic(NULL, StPer, 6, 2, 1, MODE_EMA, 0, MODE_MAIN, 1);
   if (StCurrent>70 && StPrev<70)
   {
      ball++;
   }
   else if (StCurrent>30 && StPrev<30)
   {
      ball--;
   }
 
   double forceCurr, forcePrev, forcePrevPrev;
   forceCurr=iForce(NULL, StPer, 3, MODE_EMA, PRICE_WEIGHTED, 0);
   forcePrev=iForce(NULL, StPer, 3, MODE_EMA, PRICE_WEIGHTED, 1);
   forcePrevPrev=iForce(NULL, StPer, 3, MODE_EMA, PRICE_WEIGHTED, 2);
   if (forceCurr<0 && forceCurr>forcePrev && forcePrevPrev>forcePrev) ball++;
   if (forceCurr>0 && forceCurr<forcePrev && forcePrevPrev<forcePrev) ball--;
   
   double adxMcurr, adxMprev, adxPDI, adxMDI;
   adxMcurr=iADX(NULL, StPer, 13, PRICE_CLOSE, MODE_MAIN, 0);
   adxMprev=iADX(NULL, StPer, 13, PRICE_CLOSE, MODE_MAIN, 1);
   adxPDI=iADX(NULL, StPer, 13, PRICE_CLOSE, MODE_PLUSDI, 0);
   adxMDI=iADX(NULL, StPer, 13, PRICE_CLOSE, MODE_MINUSDI, 0);
   if (adxMcurr>adxMprev)
   {
      if (adxPDI>adxMDI) ball++;
      if (adxPDI<adxMDI) ball--;
   }
   /*
   double willCurr, willPrev;
   willCurr=iWPR(NULL, StPer, 14, 0);
   willCurr=iWPR(NULL, StPer, 14, 1);
   if (willCurr<-30 && willPrev>-30) ball++;
   if (willCurr>-70 && willPrev<-70) ball++;
   */
   
   if (ball>=2) return(1);
   if (ball<=-2) return(-1);
   return(0);
}

int Thurd()                                  // ,   -  
{                                            //       
   int err, total;
   double LastH, LastL, SLB, SLS, prof;
   total=OrdersTotal();
   if(total<1)                               //        
   {
      LastH=iHigh(NULL, ThurdP, 1)+1*Point;        //   , 
      if (LastH-Ask<10*Point) LastH=Ask+10*Point;  //      -    
      LastH=NormalizeDouble(LastH, Digits);
   
      LastL=iLow(NULL, ThurdP, 1)-1*Point;         //   , 
      if (Bid-LastL<10*Point) LastL=Bid-10*Point;  //      -   
      LastL=NormalizeDouble(LastL,Digits);
   
      SLB=iLow(NULL, ThurdP, iLowest(NULL, ThurdP, MODE_LOW, 30, 1));//          30 
      if (SLB>Ask-StopLoss*Point) SLB=Ask-StopLoss*Point;            //     StopLoss
   
      SLS=iHigh(NULL, ThurdP, iHighest(NULL, ThurdP, MODE_HIGH, 30, 1)); //   - 
      if (SLS<Bid+StopLoss*Point) SLS=Bid+StopLoss*Point;
   
      ObjectSetText("my","MACD="+MACDsamp()+" Stoch="+Stoch(),8,"Arial",Snow);
      if (MACDsamp()+Stoch()==2)
      {
         if (TakeProfit==0) prof=0; else prof=LastH+TakeProfit*Point;
         err=OrderSend(Symbol(), OP_BUYSTOP, LotSize, LastH, 0, SLB, prof, NULL, magic, 0, CLR_NONE);  //  
         if (err==-1)
         {
            Alert("  BuyStop ",TxtERROR(0),"  price ", LastH,"   ", Ask," LotSize ", LotSize, "SL=", SLB);
            return(0);
         }
         return(1);
      }
      else if (MACDsamp()+Stoch()==-2)
      {
         if (TakeProfit==0) prof=0; else prof=LastL-TakeProfit*Point;
         err=OrderSend(Symbol(), OP_SELLSTOP, LotSize, LastL, 0, SLS, prof, NULL, magic, 0, CLR_NONE);  //   
         if (err==-1)
         {
            Alert("  SellStop ",TxtERROR(0),"  price ",LastL,"  ", Bid," prof ", prof, "SL=", SLB);
            return(0);
         }
         return(-1);
      }
   }
   return(0);
}

void OrdModif()              //    
{
   int tip,Ticket;
   bool error;
   double StLo,OSL,OOP;
   double LastH, LastL, SLB, SLS;
   LastH=iHigh(NULL, ThurdP, 1)+1*Point;               //      1     
   if (LastH-Ask<10*Point) LastH=Ask+10*Point;         //      -    
   
   LastL=iLow(NULL, ThurdP, 1)-1*Point;                //      1     
   if (Bid-LastL<10*Point) LastL=Bid-10*Point;         // ,    
   
   SLB=iLow(NULL, ThurdP, iLowest(NULL, ThurdP, MODE_LOW, 30, 1));   //           30 
   if (SLB>Ask-StopLoss*Point) SLB=Ask-(StopLoss*Point);             // ,    
   
   SLS=iHigh(NULL, ThurdP, iHighest(NULL, ThurdP, MODE_HIGH, 30, 1));   //           30 
   if (SLS<Bid+StopLoss*Point) SLS=Bid+StopLoss*Point;                  // ,    
   
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS)==true)
      {  tip = OrderType();
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         {
            OSL   = OrderStopLoss();
            OOP   = OrderOpenPrice();
            //if (LastH<OOP) LastH=OOP;
            //if (LastL>OOP) LastL=OOP;
            Ticket = OrderTicket();
            if (tip==OP_BUYSTOP && LastH<OOP)             
            {
               if (counterB<count)
               {
               
                  counterB++;
                  error=OrderModify(Ticket,NormalizeDouble(LastH, Digits),SLB,OrderTakeProfit(),0,White);    //         1     
                  if (error==-1)
                  {
                     Alert("  Buy ",TxtERROR(0),"  price ",NormalizeDouble(LastH, Digits),"   ",Symbol()," LotSize ", LotSize);
                     return(0);
                  }
               
               }
               else 
               { 
                  OrderDelete(Ticket);           //       count ,  
                  counterB=0;
               }
            } 
            if (tip==OP_SELLSTOP && LastL>OOP && MACDsamp()+Stoch()<=-1)        
            {
               if (counterS<count)
               {
                  counterS++;
                  error=OrderModify(Ticket,NormalizeDouble(LastL, Digits),SLS,OrderTakeProfit(),0,White);      //         1     
                  if (error==-1)
                  {
                     Alert("  Buy ",TxtERROR(0),"  price ",NormalizeDouble(LastL, Digits),"   ",Symbol()," LotSize ", LotSize);
                     return(0);
                  }
               }
               else 
               {
                  OrderDelete(Ticket);        //       ount ,  
                  counterS=0;
               }
            } 
         }
      }
   }
}

void TrailingStop(int tral)          //      , 
{                                    //     MA
   int tip,Ticket;
   bool error;
   double StLo,OSL,OOP, MAcurr, MAprev; 
   
   MAcurr=iMA(NULL, PERIOD_M5, MAper, 0, MODE_EMA, PRICE_CLOSE, 0);
   MAprev=iMA(NULL, PERIOD_M5, MAper, 0, MODE_EMA, PRICE_CLOSE, 1);
   
   //ObjectSetText("my","MAcurr+"+MAcurr+" MAprev="+MAprev,12,"Arial",Snow);
   
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS)==true)
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         {
            OSL   = OrderStopLoss();
            OOP   = OrderOpenPrice();
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               if (Bid>OOP && MAcurr<MAprev)                                                                      //      
               {
                  error=OrderClose(Ticket, LotSize, NormalizeDouble(Bid, 4), 0, CLR_NONE);                        //  
                  if (!error) Print(Symbol(),"   Error order ",Ticket," TrailingStop ",GetLastError());
               } else if (OSL<OOP-StopLoss*Point && !1)                                                           //       -  (   "&& !1") 
               {
                  error=OrderModify(Ticket,OOP,OOP-StopLoss*Point,OrderTakeProfit(),0,White);
                  Comment("TrailingStop ",Ticket," ",TimeToStr(TimeCurrent(),TIME_MINUTES));
                  //Sleep(500);
                  if (!error) Print(Symbol(),"   Error order ",Ticket," TrailingStop ",GetLastError());
               }
               if ((OSL<OOP && OOP>Bid-tral*Point) /*|| OSL>OOP*/) continue;                                      //  
               StLo = NormalizeDouble(Bid - tral*Point,Digits); 
               Alert("OSL=", OSL, " OOP=", OOP, " StLo=", StLo);
               if (StLo > OSL && StLo >= OOP /*&& StLo<Bid-10*Point*/)
               {  error=OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White);
                  Comment("TrailingStop ",Ticket," ",TimeToStr(TimeCurrent(),TIME_MINUTES));
                  //Sleep(500);
                  if (!error) Print(Symbol(),"   Error order ",Ticket," TrailingStop ",GetLastError());
               }
            }                                         
            if (tip==OP_SELL)        
            {
               if (Ask<OOP && MAcurr>MAprev)                                                                      //      
               {
                  error=OrderClose(Ticket, LotSize, NormalizeDouble(Ask, 4), 0, CLR_NONE); 
                  if (!error) Print(Symbol(),"   Error order ",Ticket," Ask=", Ask, " bid=", Bid);
               } else if (OSL>OOP+StopLoss*Point && !1)
               {
                  error=OrderModify(Ticket,OOP,OOP+StopLoss*Point,OrderTakeProfit(),0,White);
                  Comment("TrailingStop ",Ticket," ",TimeToStr(TimeCurrent(),TIME_MINUTES));
                  //Sleep(500);
                  if (!error) Print(Symbol(),"   Error order ",Ticket," TrailingStop ",GetLastError());
               }
               if ((OSL>OOP && OSL!=0 && OOP<Ask+tral*Point) /*|| OSL<OOP*/) continue;
               StLo = NormalizeDouble(Ask + tral*Point,Digits);
               if ((StLo < OSL||OSL==0) && StLo <= OOP && StLo>Ask+10*Point)
               {  error=OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White);
                  Comment("TrailingStop ",Ticket," ",TimeToStr(TimeCurrent(),TIME_MINUTES));
                  //Sleep(500);
                  if (!error) Print(Symbol(),"   Error order ",Ticket," TrailingStop ",GetLastError());
               }
            } 
         }
      }
   }
}

void Lot()
{
   if (AccountBalance()/dep>=2) 
   { 
      LotSize=LotSize+LotSize/2;
      dep=AccountBalance();
   }
}

string TxtERROR(int e)
{
   if (e==0) e = GetLastError();
   switch ( e )
   {                  
      case 0:   return;
      case 1:   return;
      case 2:   return("   ");
      case 3:   return("    ");
      case 6:   return("       ");
      case 130: return("    ");
      case 131: return("  ");
      case 132: return("  ");
      case 133: return("  ");
      case 134: return("    ");
      case 136: return("  ");
      case 146: return("   ");
      case 129: return("  ");
      case 131: return("  ");
      case 4051:return("    ");
      case 4059:return("     ");
      case 4063:return("   integer ");
      case 4105:return("     ");
      case 4107:return("      ");
      case 4108:return("   ");
      case 4109:return("  .    `  `   .");
      case 4200:return("   ");
      default:  return(StringConcatenate("Error  ",e,"   "));
   }
}

